#! /usr/bin/perl

#   	 Make Encapsulated PostScript from PostScript File

#   	       by John Walker  --  November 2003
#   	      This program is in the public domain.

    use warnings;
    
    $psfile = 'evilempires';
    
    #	Make first-cut EPS file
    &syscmd("ps2epsi $psfile.ps $psfile.tmp");
    
    #	Compute regular and high-resolution bounding boxes
    &syscmd("gs -q -dNOPAUSE -sDEVICE=bbox $psfile.ps quit.ps 2>${psfile}1.tmp");
    open(IP, "<${psfile}1.tmp");
    @bbox = <IP>;
    close(IP);
    &syscmd("rm -f ${psfile}1.tmp");
    
    #	Transcribe generated EPS, interpolating our comments
    open(FI, "<$psfile.tmp");
    open(FO, ">$psfile.eps");
    
    $lfirst = 1;
    while ($l = <FI>) {
    	chomp($l);
	
	if ($l =~ m/^%!PS-Adobe/) {
	    print(FO "$l\n");
	    for ($i = 0; $i <= $#bbox; $i++) {
	    	chomp($bbox[$i]);
	    	print(FO "$bbox[$i]\n");
	    }
	    next;
	} elsif (($l =~ m/^%%Title/) ||
	    	 ($l =~ m/^%%Creator/) ||
	    	 ($l =~ m/^%%CreationDate/) ||
	    	 ($l =~ m/^%%For/) ||
	    	 ($l =~ m/^%BoundingBox/)) {
	    next;
	} elsif (($l =~ m/^%%Page /) && $lfirst) {
	    $lfirst = 0;
	    next;
	}
	
	print(FO "$l\n");
    }
    close(FI);
    close(FO);
    
    &syscmd("rm -f $psfile.tmp");
    
    #	Echo and execute a system command
    sub syscmd {
    	my ($cmd) = @_;
	
	print(STDERR "$cmd\n");
	system($cmd);
    }
